Packager: Igor Vlasenko <viy@altlinux.ru>
BuildRequires: /proc
BuildRequires: jpackage-compat
# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support 0

%define repo_dir    m2_repo/repository

Name:           xbean
Version:        3.3
Release:        alt1_1jpp5
Epoch:          0
Summary:        XBean plugin based server
License:        Apache Software License 2.0
Group:          Development/Java
URL:            http://geronimo.apache.org/xbean
Source0:        xbean-3.3-src.tar.gz
# svn export http://svn.apache.org/repos/asf/geronimo/xbean/tags/xbean-3.3/

Source2:        %{name}-jpp-depmap.xml
Source3:        %{name}-settings.xml
Source4:        apache-3.pom
Source6:        apache-jar-resource-bundle-1.3.jar
Source7:        org.eclipse.osgi.jar
Patch0:         %{name}-%{version}-pom.patch

BuildRequires: jpackage-utils >= 0:1.7.5
BuildRequires: ant >= 0:1.6.5
BuildRequires: cglib
BuildRequires: maven2 >= 0:2.0.7
BuildRequires: maven2-plugin-ant
BuildRequires: maven2-plugin-antrun
BuildRequires: maven2-plugin-compiler
BuildRequires: maven2-plugin-gpg
BuildRequires: maven2-plugin-idea
BuildRequires: maven2-plugin-install
BuildRequires: maven2-plugin-jar
BuildRequires: maven2-plugin-javadoc
BuildRequires: maven2-plugin-plugin
BuildRequires: maven2-plugin-pmd
BuildRequires: maven2-plugin-resources
BuildRequires: maven2-plugin-source
BuildRequires: maven-surefire-plugin
BuildRequires: maven-release
BuildRequires: maven2-plugin-dependency
BuildRequires: maven-jxr
BuildRequires: felix-maven2

BuildRequires: asm2
BuildRequires: backport-util-concurrent
BuildRequires: stax_1_0_api
BuildRequires: groovy-jsr
BuildRequires: jakarta-commons-logging
BuildRequires: junit
BuildRequires: mx4j
BuildRequires: plexus-archiver
BuildRequires: plexus-utils
BuildRequires: qdox
BuildRequires: spring2-beans
BuildRequires: spring2-context
BuildRequires: spring2-core
BuildRequires: spring2-web
BuildRequires: xpp3-minimal

Requires: ant >= 0:1.6.5
Requires: asm2
Requires: backport-util-concurrent
Requires: stax_1_0_api
Requires: groovy-jsr
Requires: jakarta-commons-logging
Requires: junit
Requires: mx4j
Requires: plexus-archiver
Requires: plexus-utils
Requires: qdox
Requires: spring-all
Requires: spring2-all

Requires(post): jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5

%if %{gcj_support}
BuildRequires: gnu-crypto
BuildRequires: java-gcj-compat-devel
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif

%description
The goal of XBean project is to created a plugin based 
server analogous to Eclipse being a plugin based IDE. 
XBean will be able to discover, download and install 
server plugins from an Internet based repository. In 
addition, we include support for multiple IoC systems, 
support for running with no IoC system, JMX without JMX 
code, lifecycle and class loader management, and a rock 
solid Spring integration.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q 
%patch0 -b .sav0

cp %{SOURCE3} maven2-settings.xml

%build
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir -p m2_repo/repository/JPP/maven2/default_poms
cp %{SOURCE4} m2_repo/repository/JPP/maven2/default_poms/org.apache-apache.pom
cp pom.xml m2_repo/repository/JPP/maven2/default_poms/JPP.xbean-xbean.pom
cp maven-xbean-plugin/pom.xml m2_repo/repository/JPP/maven2/default_poms/org.apache.xbean-maven-xbean-plugin.pom

mkdir -p m2_repo/repository/org.apache
cp %{SOURCE6} m2_repo/repository/org.apache/apache-jar-resource-bundle.jar

mkdir -p m2_repo/repository/org.apache.xbean/
ln -sf $(pwd)/m2_repo/repository/org/apache/xbean/xbean-spring-common/%{version}/xbean-spring-common-%{version}.jar \
              m2_repo/repository/org.apache.xbean/xbean-spring-common.jar
ln -sf $(pwd)/m2_repo/repository/org/apache/xbean/xbean-spring-v1/%{version}/xbean-spring-v1-%{version}.jar \
              m2_repo/repository/org.apache.xbean/xbean-spring-v1.jar
ln -sf $(pwd)/m2_repo/repository/org/apache/xbean/xbean-spring-v2/%{version}/xbean-spring-v2-%{version}.jar \
              m2_repo/repository/org.apache.xbean/xbean-spring-v2.jar
mkdir -p m2_repo/repository/org.apache.xbean/
ln -sf $(pwd)/m2_repo/repository/org/apache/xbean/maven-xbean-plugin/%{version}/maven-xbean-plugin-%{version}.jar \
              m2_repo/repository/org.apache.xbean/maven-xbean-plugin.jar

rm -rf xbean-osgi/src/test

mkdir -p m2_repo/repository/org.eclipse.equinox/
cp %{SOURCE7} m2_repo/repository/org.eclipse.equinox/osgi.jar

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository

mvn-jpp \
        -e \
        -s $M2SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.test.failure.ignore=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        ant:ant install javadoc:javadoc

%install
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 maven-%{name}-plugin/target/maven-%{name}-plugin-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/maven-%{name}-plugin-%{version}.jar
install -m 644 %{name}-classloader/target/%{name}-classloader-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-classloader-%{version}.jar
install -m 644 %{name}-classloader/target/alternate.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-classloader-alternate-%{version}.jar
install -m 644 %{name}-classpath/target/%{name}-classpath-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-classpath-%{version}.jar
install -m 644 %{name}-finder/target/%{name}-finder-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-finder-%{version}.jar
install -m 644 %{name}-kernel/target/%{name}-kernel-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-kernel-%{version}.jar
#install -m 644 %{name}-osgi/target/%{name}-osgi-%{version}.jar \
#  $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-osgi-%{version}.jar
install -m 644 %{name}-naming/target/%{name}-naming-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-naming-%{version}.jar
install -m 644 %{name}-reflect/target/%{name}-reflect-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-reflect-%{version}.jar
install -m 644 %{name}-server/target/%{name}-server-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-server-%{version}.jar

install -m 644 %{name}-spring/target/%{name}-spring-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-spring-%{version}.jar

install -m 644 %{name}-telnet/target/%{name}-telnet-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-telnet-%{version}.jar
install -m 644 %{name}-tiger/target/%{name}-tiger-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-tiger-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

(cd ${RPM_BUILD_ROOT}%{_datadir}/maven2/plugins && ln -sf %{_javadir}/%{name}/maven-%{name}-plugin-%{version}.jar maven-%{name}-plugin.jar)

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
cp pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{name}.pom
%add_to_maven_depmap org.apache.xbean %{name} %{version} JPP/%{name} %{name}
cp maven-%{name}-plugin/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-maven-%{name}-plugin.pom
%add_to_maven_depmap org.apache.xbean maven-%{name}-plugin %{version} JPP/%{name} maven-%{name}-plugin
cp %{name}-classloader/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{name}-classloader.pom
%add_to_maven_depmap org.apache.xbean %{name}-classloader %{version} JPP/%{name} %{name}-classloader
cp %{name}-classpath/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{name}-classpath.pom
%add_to_maven_depmap org.apache.xbean %{name}-classpath %{version} JPP/%{name} %{name}-classpath
cp %{name}-finder/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{name}-finder.pom
%add_to_maven_depmap org.apache.xbean %{name}-finder %{version} JPP/%{name} %{name}-finder
cp %{name}-kernel/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{name}-kernel.pom
%add_to_maven_depmap org.apache.xbean %{name}-kernel %{version} JPP/%{name} %{name}-kernel
cp %{name}-osgi/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{name}-osgi.pom
%add_to_maven_depmap org.apache.xbean %{name}-osgi %{version} JPP/%{name} %{name}-osgi
cp %{name}-naming/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{name}-naming.pom
%add_to_maven_depmap org.apache.xbean %{name}-naming %{version} JPP/%{name} %{name}-naming
cp %{name}-reflect/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{name}-reflect.pom
%add_to_maven_depmap org.apache.xbean %{name}-reflect %{version} JPP/%{name} %{name}-reflect
cp %{name}-server/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{name}-server.pom
%add_to_maven_depmap org.apache.xbean %{name}-server %{version} JPP/%{name} %{name}-server
cp %{name}-spring/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{name}-spring.pom
%add_to_maven_depmap org.apache.xbean %{name}-spring %{version} JPP/%{name} %{name}-spring
cp %{name}-telnet/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{name}-telnet.pom
%add_to_maven_depmap org.apache.xbean %{name}-telnet %{version} JPP/%{name} %{name}-telnet
cp %{name}-tiger/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{name}-tiger.pom
%add_to_maven_depmap org.apache.xbean %{name}-tiger %{version} JPP/%{name} %{name}-tiger


# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/maven-%{name}-plugin
cp -pr maven-%{name}-plugin/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/maven-%{name}-plugin
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/classloader
cp -pr %{name}-classloader/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/classloader
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/classpath
cp -pr %{name}-classpath/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/classpath
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/finder
cp -pr %{name}-finder/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/finder
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/kernel
cp -pr %{name}-kernel/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/kernel
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/osgi
cp -pr %{name}-osgi/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/osgi
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/naming
cp -pr %{name}-naming/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/naming
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/reflect
cp -pr %{name}-reflect/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/reflect
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/server
cp -pr %{name}-server/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/server
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/spring
cp -pr %{name}-spring/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/spring
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/telnet
cp -pr %{name}-telnet/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/telnet
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/tiger
cp -pr %{name}-tiger/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/tiger
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

%files
%doc LICENSE.txt
%{_javadir}/*
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/*-%{version}.jar.*
%endif

%files javadoc
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%changelog
* Tue Mar 03 2009 Igor Vlasenko <viy@altlinux.ru> 0:3.3-alt1_1jpp5
- first build

